/* 
 * File:   spi.h
 * Author: CYRAX
 *
 */

#ifndef SPI_H
#define	SPI_H

// Function prototypes
extern void MAX3100_init(void);
extern void initspi(void);
extern unsigned char txrxspi (unsigned char txc);
extern unsigned char MAX3100_rxrdy(void);
extern unsigned char MAX3100_receive(void);
extern void MAX3100_send(unsigned char ch);
extern void putst(register const char *str);
static void uart_write(unsigned char cbyte, unsigned char dbyte);
static unsigned char uart_status(void);

/* 3.6864MHz Crystal Baudrates */
#define BR2304 (0 << 0)   /* 230400 Baudrate **3.6864MHz Only**  |  (0000) */
#define BR1152 (1 << 0)   /* 115200 Baudrate */
#define BR576  (2 << 0)   /* 57600 Baudrate */
#define BR288  (3 << 0)   /* 28800 Baudrate */
#define BR144  (4 << 0)   /* 14400 Baudrate */
#define BR72   (5 << 0)   /* 7200 Baudrate */
#define BR36   (6 << 0)   /* 3600 Baudrate */
#define BR18   (7 << 0)   /* 1800 Baudrate */
#define BR9    (8 << 0)   /* 900 Baudrate */
#define BR384  (9 << 0)   /* 38400 Baudrate */
#define BR192  (10 << 0)   /* 19200 Baudrate */
#define BR96   (11 << 0)  /* 9600 Baudrate */
#define BR48   (12 << 0)  /* 4800 Baudrate */
#define BR24   (13 << 0)  /* 2400 Baudrate */
#define BR12   (14 << 0)  /* 1200 Baudrate */
#define BR6    (15 << 0)  /* 600 Baudrate */

#define RDDAT  (0 << 6)   /* cbyte write: read data */
#define RDCFG  (1 << 6)   /* cbyte write: read configuration */
#define WRDAT  (2 << 6)   /* cbyte write: write data */
#define WRCFG  (3 << 6)   /* cbyte write: write configuration */

#define RXRDY  (1 << 7)   /* cbyte read: receiver ready */
#define TXRDY  (1 << 6)   /* cbyte read: transmitter ready */

#define FDS    (1 << 5)   /* cfg/cbyte: receive FIFO disable */
#define SHDN   (1 << 4)   /* cfg/cbyte: shutdown */
#define TIE    (1 << 3)   /* cfg/cbyte: transmit interrupt enable */
#define RIE    (1 << 2)   /* cfg/cbyte: receive interrupt enable */
#define PIE    (1 << 1)   /* cfg/cbyte: P bit (ninth data) interrupt enable */
#define FIE    (1 << 0)   /* cfg/cbyte: activity/framing interrupt enable */

#define IRDA   (1 << 7)   /* cfg/dbyte: IRDA mode */
#define ST2    (1 << 6)   /* cfg/dbyte: two stop bit select */
#define PBE    (1 << 5)   /* cfg/dbyte: P bit (ninth data) enable */
#define DL7    (1 << 4)   /* cfg/dbyte: data length 7 bits */

#define RTSE   (1 << 2)   /* dat/cbyte write: update only RTS */
#define RAFE   (1 << 2)   /* dat/cbyte read: rx active / framing error */
#define RTS    (1 << 1)   /* dat/cbyte: request to send */
#define PBIT   (1 << 0)   /* dat/cbyte: P bit (ninth data) */
#endif	/* SPI_H */

